//+------------------------------------------------------------------+
//|                                                   VininI_CCI.mq4 |
//|                     Copyright  2011, Victor Niclolaev aka Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Victor Niclolaev aka Vinin"
#property link      "vinin@mail.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Aqua


//--- input parameters
extern int     RSIPeriod=14;
extern int     RSIPrice=0;
extern int     MAPeriod=14;
extern int     MAMode=0;
//--- buffers
double RSIBuffer[];
double ResBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(2);
//---- indicator lines
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, ResBuffer);
   SetIndexBuffer(1, RSIBuffer);

//----
   if(RSIPeriod <= 0)
       RSIPeriod = 14;
//----
  
//---- name for DataWindow and indicator subwindow label
//----
  return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int    i, k, counted_bars = IndicatorCounted();
   double price, sum, mul; 
   if(RSIPeriod <= 1)      return(0);
//---- last counted bar will be recounted
   int limit1 = Bars - counted_bars;
   int limit2=limit1;
   if(limit1 > 1)  {
      limit1=Bars-RSIPeriod-1;
      limit2=limit1-RSIPeriod;
      ArrayInitialize(RSIBuffer,0);
   }
//---- moving average
   for(i = limit1; i >=0; i--) {
      RSIBuffer[i] = iRSI(NULL, 0, RSIPeriod, RSIPrice, i);
   }
   for(i = limit2; i >=0; i--) {
      ResBuffer[i] = RSIBuffer[i]-iMAOnArray(RSIBuffer,0,MAPeriod,0,MAMode,i);
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+

